main()
{
	//maps\mp\mp_factory_fx::main();
	//maps\createart\mp_factory_art::main();
	maps\mp\_load::main();	
	
	maps\mp\_compass::setupMiniMap("compass_map_mp_factory");

	//setExpFog(500, 2200, 0.81, 0.75, 0.63, 0);
	//VisionSetNaked( "mp_factory" );
	ambientPlay("ambient_factory_ext");

	game["allies"] = "sas";
	game["axis"] = "opfor";
	game["attackers"] = "axis";
	game["defenders"] = "allies";
	game["allies_soldiertype"] = "woodland";
	game["axis_soldiertype"] = "woodland";

	setdvar("r_specularcolorscale", "1" );
	setdvar("r_glowbloomintensity0",".25");
	setdvar("r_glowbloomintensity1",".25");
	setdvar("r_glowskybleedintensity0",".3");
	setdvar("compassmaxrange","1800");

	//fx
	level.fx_med_fire = loadfx("fire/firelp_med_pm");
	level.fx_fiery_explosion = loadfx("explosions/grenadeexp_fuel");
	level.fx_small_fire = loadfx("fire/firelp_small_pm");
	level.fx_cement_explosion = loadfx("explosions/wall_explosion_small");
	level.fx_pipe_explosion = loadfx("impacts/pipe_steam_looping");
	level.fx_glass_break = loadfx("props/car_glass_large");

	//grenadebutton code
	trig_grenade = getentarray("trig_grenade","targetname");
	for(i=0;i<trig_grenade.size;i++)
	{
		trig_grenade[i].grenadebuttonmodel = getent(trig_grenade[i].target, "targetname");
		trig_grenade[i].grenadebuttonmodel.grenadebuttonmoving = false;
		trig_grenade[i].grenadebuttonmodel.grenadebuttonup = true;
		trig_grenade[i].grenadebuttonmodel.time = 0.1; //how long it takes the grenadebutton to move
		trig_grenade[i] thread grenadebuttonmove();
	}

	//mist code
	mist = getentarray("mist","targetname");
	for(i=0;i<mist.size;i++)
	{
		mist[i] thread mistbegin();
	}

	//wall_explode code
	trig_wall_explode = getentarray("trig_wall_explode","targetname");
	for(i=0;i<trig_wall_explode.size;i++)
	{
		trig_wall_explode[i].burnt = false;
		trig_wall_explode[i].xaxis = false;
		trig_wall_explode[i].yaxis = false;
		if (trig_wall_explode[i].script_noteworthy == "xaxis")
		{
			trig_wall_explode[i].xaxis = true;
		}
		else if (trig_wall_explode[i].script_noteworthy == "yaxis")
		{
			trig_wall_explode[i].yaxis = true;
		}
		trig_wall_explode[i].wall_normal = getent(trig_wall_explode[i].target, "targetname");
		trig_wall_explode[i].wall_burnt = getent(trig_wall_explode[i].wall_normal.target, "targetname");
		trig_wall_explode[i].wall_burnt notSolid();
		trig_wall_explode[i].wall_burnt hide();
		trig_wall_explode[i].hurt = false;
		trig_wall_explode[i].door = false;
		trig_wall_explode[i].window = false;
		if (trig_wall_explode[i].wall_burnt.script_noteworthy == "hurt")
		{
			trig_wall_explode[i].hurt = true;
			trig_wall_explode[i].wall_hurt = getent(trig_wall_explode[i].wall_burnt.target, "targetname");
			trig_wall_explode[i] thread wall_hurt();
		}
		else if (trig_wall_explode[i].wall_burnt.script_noteworthy == "door")
		{
			trig_wall_explode[i].door = true;
			trig_wall_explode[i].trig_door_swing_ccw = getent(trig_wall_explode[i].wall_burnt.target, "targetname");
			trig_wall_explode[i].trig_door_swing_cw = getent(trig_wall_explode[i].trig_door_swing_ccw.target, "targetname");
			trig_wall_explode[i].door_model = getent(trig_wall_explode[i].trig_door_swing_cw.target, "targetname");
			trig_wall_explode[i].door_moving = false;
			trig_wall_explode[i].door_closed = true;
			trig_wall_explode[i].door_time = 1;
			trig_wall_explode[i] thread door_swing_ccw();
			trig_wall_explode[i] thread door_swing_cw();
		}
		else if (trig_wall_explode[i].wall_burnt.script_noteworthy == "window")
		{
			trig_wall_explode[i].window = true;
			trig_wall_explode[i].trig_window = getent(trig_wall_explode[i].wall_burnt.target, "targetname");
			trig_wall_explode[i].window_model = getent(trig_wall_explode[i].trig_window.target, "targetname");
			trig_wall_explode[i].window_hits = 0;
			trig_wall_explode[i].window_max_hits = 3;
			trig_wall_explode[i].window_broken = false;
			trig_wall_explode[i] thread window_break();
		}
		trig_wall_explode[i].plaster = false;
		trig_wall_explode[i].cement = false;
		trig_wall_explode[i].glass = false;
		if (trig_wall_explode[i].wall_normal.script_noteworthy == "plaster")
		{
			trig_wall_explode[i].plaster = true;
		}
		else if (trig_wall_explode[i].wall_normal.script_noteworthy == "cement")
		{
			trig_wall_explode[i].cement = true;
		}
		else if (trig_wall_explode[i].wall_normal.script_noteworthy == "glass")
		{
			trig_wall_explode[i].glass = true;
		}
		trig_wall_explode[i] thread wall_explode();
	}

	//vat_explode code
	trig_vat_explode = getentarray("trig_vat_explode","targetname");
	for(i=0;i<trig_vat_explode.size;i++)
	{
		trig_vat_explode[i].exploded = false;
		trig_vat_explode[i].attacker = "World";
		trig_vat_explode[i].bottom = getent(trig_vat_explode[i].target, "targetname");		
		trig_vat_explode[i].vat_hurt = getent(trig_vat_explode[i].bottom.target, "targetname");		
		trig_vat_explode[i].trig_skylight = getent(trig_vat_explode[i].vat_hurt.target, "targetname");		
		trig_vat_explode[i].trig_skylight.modelname = getent(trig_vat_explode[i].trig_skylight.target, "targetname");		
		trig_vat_explode[i].trig_skylight.broken = false;
		trig_vat_explode[i] thread vat_explode();
		trig_vat_explode[i] thread vat_fan_sound();
		trig_vat_explode[i] thread vat_hurt();
		trig_vat_explode[i].trig_skylight thread skylight_break();
	}

	//pipe_explode code
	trig_pipe_explode = getentarray("trig_pipe_explode","targetname");
	for(i=0;i<trig_pipe_explode.size;i++)
	{
		trig_pipe_explode[i].exploded = false;
		trig_pipe_explode[i].pipe_hurt = getent(trig_pipe_explode[i].target, "targetname");		
		trig_pipe_explode[i] thread pipe_explode();
		trig_pipe_explode[i] thread pipe_hurt();
	}

	//duct_explode code
	trig_duct_explode = getentarray("trig_duct_explode","targetname");
	for(i=0;i<trig_duct_explode.size;i++)
	{
		trig_duct_explode[i].exploded = false;
		trig_pipe_explode[i].attacker = "World";
		trig_duct_explode[i].bottom = getent(trig_duct_explode[i].target, "targetname");		
		trig_duct_explode[i].duct_hurt = getent(trig_duct_explode[i].bottom.target, "targetname");
		trig_duct_explode[i] thread duct_explode();
		trig_duct_explode[i] thread duct_hurt();
	}

	//grate code
	trig_grate = getentarray("trig_grate","targetname");
	for(i=0;i<trig_grate.size;i++)
	{
		trig_grate[i].broken = false;
		trig_grate[i].grate = getent(trig_grate[i].target, "targetname");		
		trig_grate[i] thread grate_break();
	}

	//skylight code
	trig_skylight = getentarray("trig_skylight","targetname");
	for(i=0;i<trig_skylight.size;i++)
	{
		trig_skylight[i].broken = false;
		trig_skylight[i].modelname = getent(trig_skylight[i].target, "targetname");		
		trig_skylight[i] thread skylight_break();
	}

	//fan code
	fan = getentarray("fan","targetname");
	for(i=0;i<fan.size;i++)
	{
		fan[i] thread fan_rotate();
	}
}

//fan rotate code
fan_rotate()
{
	while (true)
	{	
		self rotateYaw(360, 1);
		self playsound("fan");
		self waittill("rotatedone");
	}
}

//mistbegin code
mistbegin()
{
	level._effect["mist"] = loadfx("weather/toxic_cloud");
	maps\mp\_fx::loopfx("mist", (self.origin + (0, 0, 100)), 0.5);	
}

//grenadebutton code
grenadebuttonmove()
{
	while (1)
	{
		self waittill("trigger", user);
		if(!self.grenadebuttonmodel.grenadebuttonmoving)
		{
			self.grenadebuttonmodel.grenadebuttonmoving = true;
			if (user GetWeaponAmmoClip("frag_grenade_mp") < 4)
			{
				self playsound("givegrenade");
				user givemaxammo("frag_grenade_mp");
				wait(0.01);
			}
			self.grenadebuttonmodel movez(-1,self.grenadebuttonmodel.time);
			self.grenadebuttonmodel waittill("movedone");
			self.grenadebuttonmodel movez(1,self.grenadebuttonmodel.time);
			self.grenadebuttonmodel waittill("movedone");
			self.grenadebuttonmodel.grenadebuttonmoving = false;			
		}
	}
}

//wall_explode code
wall_explode()
{
	while (1)
	{
		self waittill("trigger", user);
		self.ground_level = -56;
		self.small_fire_offset = 20;
		self.med_fire_offset = 30;		
		if(self.cement)
		{
			PlayFX(level.fx_cement_explosion, self.origin + (0, 0, self.ground_level));
		}
		else if(self.plaster || self.glass)
		{
			PlayFX(level.fx_fiery_explosion, self.origin + (0, 0, self.ground_level));
		}
		if(!self.burnt)
		{
			self.burnt = true;
			if(self.cement && !self.door)
			{
				if (self.xaxis)
				{
					PlayFX(level.fx_small_fire, self.origin + (0, 0, self.ground_level));
					if (!self.window)
					{
						PlayFX(level.fx_small_fire, self.origin + (-1 * self.small_fire_offset, 0, 0));
						PlayFX(level.fx_small_fire, self.origin + (self.small_fire_offset, 0, 0));
					}
				}
				if (self.yaxis)
				{
					PlayFX(level.fx_small_fire, self.origin + (0, 0, self.ground_level));
					if (!self.window)
					{
						PlayFX(level.fx_small_fire, self.origin + (0, -1 * self.small_fire_offset, 0));
						PlayFX(level.fx_small_fire, self.origin + (0, self.small_fire_offset, 0));
					}
				}
			}
			else if(self.plaster && !self.door)
			{
				if (self.xaxis)
				{
					PlayFX(level.fx_med_fire, self.origin + (-1 * self.med_fire_offset, 0, self.ground_level));
					PlayFX(level.fx_med_fire, self.origin + (self.med_fire_offset, 0, self.ground_level));
					if (!self.window)
					{
						PlayFX(level.fx_med_fire, self.origin + (-1 * self.med_fire_offset, 0, 0));
						PlayFX(level.fx_med_fire, self.origin + (self.med_fire_offset, 0, 0));
					}
				}
				if (self.yaxis)
				{
					PlayFX(level.fx_med_fire, self.origin + (0, -1 * self.med_fire_offset, self.ground_level));
					PlayFX(level.fx_med_fire, self.origin + (0, self.med_fire_offset, self.ground_level));
					if (!self.window)
					{
						PlayFX(level.fx_med_fire, self.origin + (0, -1 * self.med_fire_offset, 0));
						PlayFX(level.fx_med_fire, self.origin + (0, self.med_fire_offset, 0));
					}
				}
			}
			self.wall_normal notSolid();
			self.wall_normal hide();
			self.wall_burnt show();
			self.wall_burnt Solid();
			if(self.door)
			{
				self.door_model notSolid();
				self.door_model hide();
			}
			if(self.window)
			{
				self.window_model notSolid();
				self.window_model hide();
			}
			wait(0.1);
		}
	}
}

//wall_hurt code
wall_hurt()
{
	while (1)
	{
		self.wall_hurt waittill("trigger", user);
		if(self.burnt)
		{
			RadiusDamage(user.origin, 1, 5, 5);
			wait(0.1);
		}
	}
}

//door code
door_swing_ccw()
{
	while (1)
	{
		self.trig_door_swing_ccw waittill("trigger");
		if(!self.door_moving  && !self.burnt)
		{
			self.door_moving = true;
			if(self.door_closed)
			{
				self.door_model rotateyaw(90,self.door_time,self.door_time*0.5,self.door_time*0.5);
				self.door_model playsound("doormove");
				self.door_model waittill("rotatedone");
				self.door_closed = false;
		
				//close door again
				wait 4;
				self.door_model rotateyaw(-90,self.door_time,self.door_time*0.5,self.door_time*0.5);
				self.door_model playsound("doormove");
				self.door_model waittill("rotatedone");
				self.door_closed = true;		
			}
			self.door_moving = false;
			
		}
	}
}

door_swing_cw()
{
	while (1)
	{
		self.trig_door_swing_cw waittill("trigger");
		if(!self.door_moving && !self.burnt)
		{
			self.door_moving = true;
			if(self.door_closed)
			{
				self.door_model rotateyaw(-90,self.door_time,self.door_time*0.5,self.door_time*0.5);
				self.door_model playsound("doormove");
				self.door_model waittill("rotatedone");
				self.door_closed = false;
		
				//close door again
				wait 4;
				self.door_model rotateyaw(90,self.door_time,self.door_time*0.5,self.door_time*0.5);
				self.door_model playsound("doormove");
				self.door_model waittill("rotatedone");
				self.door_closed = true;		
			}
			self.door_moving = false;
			
		}
	}
}

//window break code
window_break()
{
	while (1)
	{
		self.trig_window waittill("trigger", user);
		if(!self.window_broken)
		{
			self.window_hits = self.window_hits + 1;
			if (self.window_hits >= 3)
			{
				self.window_broken = true;
				PlayFX(level.fx_glass_break, self.window_model.origin);
				self.window_model hide();
				self.window_model notSolid();
			}
		}
	}
}

//skylight break code
skylight_break()
{
	while (1)
	{
		self waittill("trigger", user);
		self.radiusinterval = 50;
		if(!self.broken)
		{
			self.broken = true;
			PlayFX(level.fx_glass_break, self.modelname.origin + (self.radiusinterval, self.radiusinterval, 0));
			PlayFX(level.fx_glass_break, self.modelname.origin + (self.radiusinterval, -1 * self.radiusinterval, 0));
			PlayFX(level.fx_glass_break, self.modelname.origin + (-1 * self.radiusinterval, self.radiusinterval, 0));
			PlayFX(level.fx_glass_break, self.modelname.origin + (-1 * self.radiusinterval, -1 * self.radiusinterval, 0));
			self.modelname hide();
			self.modelname notSolid();
		}
	}
}

//grate break code
grate_break()
{
	while (1)
	{
		self waittill("trigger", user);
		if(!self.broken)
		{
			self.broken = true;
			self.grate playsound("gratebreak");
			self.grate hide();				
			self.grate notSolid();
		}
	}
}

//pipe explode code
pipe_explode()
{
	while (1)
	{
		self waittill("trigger", user);
		if(!self.exploded)
		{
			self.exploded = true;
			PlayFX(level.fx_pipe_explosion, self.origin);
		}
	}
}

//pipe_hurt code
pipe_hurt()
{
	while (1)
	{
		self.pipe_hurt waittill("trigger", user);
		if(self.exploded)
		{
			RadiusDamage(user.origin, 1, 10, 10);
			wait(0.1);
		}
	}
}

//duct explode code
duct_explode()
{
	while (1)
	{
		self waittill("trigger", user);
		if(!self.exploded)
		{
			for(j=0;j<6;j++)
			{	
				PlayFX(level.fx_fiery_explosion, self.bottom.origin + (0,0,j*128));
			}
			wait(0.1);
			self.attacker = user;
			self.exploded = true;
			wait(0.1);
			self.exploded = false;
		}
	}
}

//duct_hurt code
duct_hurt()
{
	while (1)
	{
		self.duct_hurt waittill("trigger", user);
		if(self.exploded)
		{
			RadiusDamage(user.origin, 1, 1000, 1000, self.attacker);
			wait(0.1);
		}
	}
}

//vat explode code
vat_explode()
{
	while (1)
	{
		self waittill("trigger", user);
		if(!self.exploded)
		{
			for(j=0;j<4;j++)
			{	
				PlayFX(level.fx_fiery_explosion, self.bottom.origin + (0,0,j*128));
			}
			if (!self.trig_skylight.broken)
			{
				self.radiusinterval = 50;
				self.trig_skylight.broken = true;
				PlayFX(level.fx_glass_break, self.trig_skylight.modelname.origin + (self.radiusinterval, self.radiusinterval, 0));
				PlayFX(level.fx_glass_break, self.trig_skylight.modelname.origin + (self.radiusinterval, -1 * self.radiusinterval, 0));
				PlayFX(level.fx_glass_break, self.trig_skylight.modelname.origin + (-1 * self.radiusinterval, self.radiusinterval, 0));
				PlayFX(level.fx_glass_break, self.trig_skylight.modelname.origin + (-1 * self.radiusinterval, -1 * self.radiusinterval, 0));
				self.trig_skylight.modelname hide();
				self.trig_skylight.modelname notSolid();
			}
			wait(0.1);
			self.attacker = user;
			self.exploded = true;
			wait(0.1);
			self.exploded = false;
		}
	}
}

//vat fan sound code
vat_fan_sound()
{
	while (true)
	{	
		self playsound("fan");
		wait(1);
	}
}

//vat_hurt code
vat_hurt()
{
	while (1)
	{
		self.vat_hurt waittill("trigger", user);
		if(self.exploded)
		{
			RadiusDamage(user.origin, 1, 1000, 1000, self.attacker);
			wait(0.1);
		}
	}
}